'                                                                  
' Copyright  2013 Lidor Systems.
' All Rights Reserved.
'
' This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
' either express or implied.                        
'

Imports LidorSystems.IntegralUI.Lists

Public Class Form1

#Region "Variables"
    Private randomInts As Integer() = New Integer() {1, 2, 0, 4, 5, 3, 2, 0, 1}
    Private nodeCount As Integer = 0
    Private expanded As Boolean = False
#End Region

#Region "Initialization"
    Public Sub New()
        InitializeComponent()

        CreateLabelContent()

        InitList()
    End Sub

    Private Sub CreateLabelContent()
        Dim content As [String] = "<div style=""font:Verdana,9,r""><p>   In this sample we are demonstrating how to expand nodes vertically in upward, downward or in both directions.</p><br></br>"
        content += "<p>   By default each node expands in a way that all child nodes are shown below its parent node. If you select the <b>Up</b> option from control panel, you will notice that each child node now is displayed above its parent node.</p><br></br>"
        content += "<p>   Further more there are cases when you need to display child nodes in both directions, to see how this works select the <b>Both</b> option from control panel.</p>"
        content += "</div>"

        Me.labelInfo.Content = content
    End Sub

    Private Sub InitList()
        Me.treeView1.SuspendUpdate()
        Me.treeView1.Nodes.Clear()

        nodeCount = 0

        CreateNode(Me.treeView1.RootNode, "", 0)

        Me.treeView1.ResumeUpdate()
    End Sub

    Private Sub CreateNode(ByVal parentNode As LidorSystems.IntegralUI.Lists.TreeNode, ByVal prefix As [String], ByVal level As Integer)
        If level = 5 Then
            Return
        End If

        Dim limit As Integer = randomInts(nodeCount Mod 9)
        If level = 0 Then
            limit = 10
        End If

        Dim node As LidorSystems.IntegralUI.Lists.TreeNode = Nothing
        For i As Integer = 1 To limit
            node = New LidorSystems.IntegralUI.Lists.TreeNode("Node " & Convert.ToString(prefix) & i.ToString())
            If rbDown.Checked Then
                node.DisplayPosition = TreeNodeDisplayPosition.Below
            ElseIf rbUp.Checked Then
                node.DisplayPosition = TreeNodeDisplayPosition.Above
            Else
                If nodeCount Mod 2 = 0 Then
                    node.DisplayPosition = TreeNodeDisplayPosition.Above
                End If
            End If


            parentNode.Nodes.Add(node)
            nodeCount += 1

            CreateNode(node, Convert.ToString(prefix) & i.ToString(), level + 1)
        Next
    End Sub
#End Region

#Region "Update"
    Private Sub btnUpdate_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnUpdate.Click
        InitList()

        expanded = False
        Me.btnToggle.Text = "Expand All"
    End Sub

    Private Sub btnToggle_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnToggle.Click
        If expanded Then
            Me.treeView1.CollapseAll()
            Me.btnToggle.Text = "Expand All"
        Else
            Me.treeView1.ExpandAll()
            Me.btnToggle.Text = "Collapse All"
        End If

        expanded = Not expanded
    End Sub
#End Region

End Class
